from django.shortcuts import render

from spread_core import mqtt
from spread_core.bam.subgineries import Incubator
from spread_core.tools.settings_const import CYCLES_FROM_0
from spread_dashboard.project import bam


def locations(request):
    return render(
        request, 'incubator/locations.html',
        dict(
            broker=bam.broker_auth(),
            start_from_0=bam.settings.get(CYCLES_FROM_0, False),
            locations=mqtt.project.TopicProject.locations(bam.project.id),
            cycles=mqtt.local.Cycles.empty(bam.project.id),
            states=mqtt.spread.topic.State(
                mqtt.spread.address.SubgineryAddress.broadcast(bam.project.id, subginery_type=Incubator.__name__)
            ),
            start_index=0 if bam.settings.get(CYCLES_FROM_0, False) else 1
        )
    )


def cycles(request):
    return render(request, 'incubator/cycles.html', dict(
        broker=bam.broker_auth(),
        cycles=mqtt.local.Cycles.empty(bam.project.id),
        triggers=mqtt.local.CycleTrigger(bam.project.id, '+', ''),
        start_index=0 if bam.settings.get(CYCLES_FROM_0, False) else 1
    ))


def cycle(request, cid):
    return render(request, 'incubator/cycle.html', dict(
        start_index=0 if bam.settings.get(CYCLES_FROM_0, False) else 1,
        broker=bam.broker_auth(),
        data=str(mqtt.local.Cycles(bam.project.id, cid)),
        triggers = mqtt.local.CycleTrigger(bam.project.id, cid, ''),
    ))
